<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>iipsrv: TPTImage.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="iip.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">iipsrv
   &#160;<span id="projectnumber">1.1</span>
   </div>
   <div id="projectbrief">iipsrv is an advanced high-performance feature-rich image server for web-based streamed viewing and zooming of ultra high-resolution images</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('TPTImage_8h_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">TPTImage.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Tiled Pyramidal Tiff class interface</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">/*  IIPImage Tiled Pyramidal TIFF Class</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">    Copyright (C) 2000-2017 Ruven Pillay.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">    This program is free software; you can redistribute it and/or modify</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">    it under the terms of the GNU General Public License as published by</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">    the Free Software Foundation; either version 3 of the License, or</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">    (at your option) any later version.</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">    This program is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">    GNU General Public License for more details.</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">    You should have received a copy of the GNU General Public License</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">    along with this program; if not, write to the Free Software Foundation,</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">    Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#ifndef _TPTIMAGE_H</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#define _TPTIMAGE_H</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;IIPImage.h&quot;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;tiff.h&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;tiffio.h&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classTPTImage.html">   35</a></span>&#160;<span class="keyword">class </span><a class="code" href="classTPTImage.html">TPTImage</a> : <span class="keyword">public</span> <a class="code" href="classIIPImage.html">IIPImage</a> {</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; <span class="keyword">private</span>:</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;  TIFF *tiff;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;  tdata_t tile_buf;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; <span class="keyword">public</span>:</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classTPTImage.html#a05c20a96469793b64660eb80fe7e13fa">   49</a></span>&#160;  <a class="code" href="classTPTImage.html#a05c20a96469793b64660eb80fe7e13fa">TPTImage</a>():<a class="code" href="classIIPImage.html">IIPImage</a>(), tiff( NULL ), tile_buf( NULL ) {};</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="classTPTImage.html#a1ab5b59e27b061f833f0b439487112a9">   54</a></span>&#160;  <a class="code" href="classTPTImage.html#a1ab5b59e27b061f833f0b439487112a9">TPTImage</a>( <span class="keyword">const</span> std::string&amp; path ): <a class="code" href="classIIPImage.html">IIPImage</a>( path ), tiff( NULL ), tile_buf( NULL ) {};</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="classTPTImage.html#a9dcff8fd787e7e997ce0c226c07dc009">   59</a></span>&#160;  <a class="code" href="classTPTImage.html#a9dcff8fd787e7e997ce0c226c07dc009">TPTImage</a>( <span class="keyword">const</span> <a class="code" href="classTPTImage.html">TPTImage</a>&amp; image ): <a class="code" href="classIIPImage.html">IIPImage</a>( image ), tiff( NULL ),tile_buf( NULL ) {};</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="classTPTImage.html#ab0c4ba59e103f9a5464d14a64447031d">   64</a></span>&#160;  <a class="code" href="classTPTImage.html">TPTImage</a>&amp; <a class="code" href="classTPTImage.html#ab0c4ba59e103f9a5464d14a64447031d">operator = </a>( <a class="code" href="classTPTImage.html">TPTImage</a> image ) {</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordflow">if</span>( <span class="keyword">this</span> != &amp;image ){</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;      <a class="code" href="classTPTImage.html#a1bee422725f55c2bfc62809bf04bc5ef">closeImage</a>();</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;      <a class="code" href="classIIPImage.html#a33361969aaa0f0c8a458859951b79c21">IIPImage::operator=</a>(image);</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;      tiff = image.tiff;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;      tile_buf = image.tile_buf;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    }</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  }</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="classTPTImage.html#a3c7ae9dca794d0843a079ac7989f29bb">   77</a></span>&#160;  <a class="code" href="classTPTImage.html#a3c7ae9dca794d0843a079ac7989f29bb">TPTImage</a>( <span class="keyword">const</span> <a class="code" href="classIIPImage.html">IIPImage</a>&amp; image ): <a class="code" href="classIIPImage.html">IIPImage</a>( image ) {</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    tiff = NULL; tile_buf = NULL; </div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;  };</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno"><a class="line" href="classTPTImage.html#a3f271dc88f2c07aa4752b5bb5692baf9">   82</a></span>&#160;  <a class="code" href="classTPTImage.html#a3f271dc88f2c07aa4752b5bb5692baf9">~TPTImage</a>() { <a class="code" href="classTPTImage.html#a1bee422725f55c2bfc62809bf04bc5ef">closeImage</a>(); };</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classTPTImage.html#a8ebaea7be1a5cdac31eac9cf1c684b7c">openImage</a>();</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classTPTImage.html#a0b4a82bb950818c1196377a8ee32930d">loadImageInfo</a>( <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y );</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classTPTImage.html#a1bee422725f55c2bfc62809bf04bc5ef">closeImage</a>();</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;  <a class="code" href="classRawTile.html">RawTile</a> <a class="code" href="classTPTImage.html#a475f61c355abbeaf4a234c61f6d88ace">getTile</a>( <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r, <span class="keywordtype">int</span> l, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> t );</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;};</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classTPTImage_html"><div class="ttname"><a href="classTPTImage.html">TPTImage</a></div><div class="ttdoc">Image class for Tiled Pyramidal Images: Inherits from IIPImage. Uses libtiff. </div><div class="ttdef"><b>Definition:</b> TPTImage.h:35</div></div>
<div class="ttc" id="classTPTImage_html_a475f61c355abbeaf4a234c61f6d88ace"><div class="ttname"><a href="classTPTImage.html#a475f61c355abbeaf4a234c61f6d88ace">TPTImage::getTile</a></div><div class="ttdeci">RawTile getTile(int x, int y, unsigned int r, int l, unsigned int t)</div><div class="ttdoc">Overloaded function for getting a particular tile. </div></div>
<div class="ttc" id="classTPTImage_html_a9dcff8fd787e7e997ce0c226c07dc009"><div class="ttname"><a href="classTPTImage.html#a9dcff8fd787e7e997ce0c226c07dc009">TPTImage::TPTImage</a></div><div class="ttdeci">TPTImage(const TPTImage &amp;image)</div><div class="ttdoc">Copy Constructor. </div><div class="ttdef"><b>Definition:</b> TPTImage.h:59</div></div>
<div class="ttc" id="classTPTImage_html_a0b4a82bb950818c1196377a8ee32930d"><div class="ttname"><a href="classTPTImage.html#a0b4a82bb950818c1196377a8ee32930d">TPTImage::loadImageInfo</a></div><div class="ttdeci">void loadImageInfo(int x, int y)</div><div class="ttdoc">Overloaded function for loading TIFF image information. </div></div>
<div class="ttc" id="classTPTImage_html_a05c20a96469793b64660eb80fe7e13fa"><div class="ttname"><a href="classTPTImage.html#a05c20a96469793b64660eb80fe7e13fa">TPTImage::TPTImage</a></div><div class="ttdeci">TPTImage()</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> TPTImage.h:49</div></div>
<div class="ttc" id="classTPTImage_html_a3c7ae9dca794d0843a079ac7989f29bb"><div class="ttname"><a href="classTPTImage.html#a3c7ae9dca794d0843a079ac7989f29bb">TPTImage::TPTImage</a></div><div class="ttdeci">TPTImage(const IIPImage &amp;image)</div><div class="ttdoc">Construct from an IIPImage object. </div><div class="ttdef"><b>Definition:</b> TPTImage.h:77</div></div>
<div class="ttc" id="classTPTImage_html_a3f271dc88f2c07aa4752b5bb5692baf9"><div class="ttname"><a href="classTPTImage.html#a3f271dc88f2c07aa4752b5bb5692baf9">TPTImage::~TPTImage</a></div><div class="ttdeci">~TPTImage()</div><div class="ttdoc">Destructor. </div><div class="ttdef"><b>Definition:</b> TPTImage.h:82</div></div>
<div class="ttc" id="classIIPImage_html"><div class="ttname"><a href="classIIPImage.html">IIPImage</a></div><div class="ttdoc">Main class to handle the pyramidal image source. </div><div class="ttdef"><b>Definition:</b> IIPImage.h:62</div></div>
<div class="ttc" id="classTPTImage_html_a1bee422725f55c2bfc62809bf04bc5ef"><div class="ttname"><a href="classTPTImage.html#a1bee422725f55c2bfc62809bf04bc5ef">TPTImage::closeImage</a></div><div class="ttdeci">void closeImage()</div><div class="ttdoc">Overloaded function for closing a TIFF image. </div></div>
<div class="ttc" id="classTPTImage_html_ab0c4ba59e103f9a5464d14a64447031d"><div class="ttname"><a href="classTPTImage.html#ab0c4ba59e103f9a5464d14a64447031d">TPTImage::operator=</a></div><div class="ttdeci">TPTImage &amp; operator=(TPTImage image)</div><div class="ttdoc">Assignment Operator. </div><div class="ttdef"><b>Definition:</b> TPTImage.h:64</div></div>
<div class="ttc" id="classIIPImage_html_a33361969aaa0f0c8a458859951b79c21"><div class="ttname"><a href="classIIPImage.html#a33361969aaa0f0c8a458859951b79c21">IIPImage::operator=</a></div><div class="ttdeci">IIPImage &amp; operator=(IIPImage image)</div><div class="ttdoc">Assignment operator. </div><div class="ttdef"><b>Definition:</b> IIPImage.h:375</div></div>
<div class="ttc" id="classTPTImage_html_a8ebaea7be1a5cdac31eac9cf1c684b7c"><div class="ttname"><a href="classTPTImage.html#a8ebaea7be1a5cdac31eac9cf1c684b7c">TPTImage::openImage</a></div><div class="ttdeci">void openImage()</div><div class="ttdoc">Overloaded function for opening a TIFF image. </div></div>
<div class="ttc" id="classTPTImage_html_a1ab5b59e27b061f833f0b439487112a9"><div class="ttname"><a href="classTPTImage.html#a1ab5b59e27b061f833f0b439487112a9">TPTImage::TPTImage</a></div><div class="ttdeci">TPTImage(const std::string &amp;path)</div><div class="ttdoc">Constructor. </div><div class="ttdef"><b>Definition:</b> TPTImage.h:54</div></div>
<div class="ttc" id="classRawTile_html"><div class="ttname"><a href="classRawTile.html">RawTile</a></div><div class="ttdoc">Class to represent a single image tile. </div><div class="ttdef"><b>Definition:</b> RawTile.h:45</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><b>TPTImage.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.14 </li>
  </ul>
</div>
</body>
</html>
